import { lucid } from "../deps.ts";
import * as bp from "./blueprint.ts";

export type Context = bp.XContext["_"]
export const Context = bp.XContext["_"]

export function contextToData(x: Context): string {
  return lucid.Data.to<Context>(x, Context);
}

export function contextfromData(x: string): Context {
  return lucid.Data.from<Context>(x, Context);
}

export type StatementData = bp.XStatementData["_"]
export const StatementData = bp.XStatementData["_"]

export function statementDataToData(x: StatementData): string {
  return lucid.Data.to<StatementData>(x, StatementData);
}

export function statementDatafromData(x: string): StatementData {
  return lucid.Data.from<StatementData>(x, StatementData);
}

export type DatumData = bp.XDatumData["_"]
export const DatumData = bp.XDatumData["_"]

export function datumDataToData(x: DatumData): string {
  return lucid.Data.to<DatumData>(x, DatumData);
}

export function datumDatafromData(x: string): DatumData {
  return lucid.Data.from<DatumData>(x, DatumData);
}

export type Price = bp.XPrice["_"]
export const Price = bp.XPrice["_"]

export function priceToData(x: Price): string {
  return lucid.Data.to<Price>(x, Price);
}

export function pricefromData(x: string): Price {
  return lucid.Data.from<Price>(x, Price);
}

export type StatementPrice = bp.XStatementPrice["_"]
export const StatementPrice = bp.XStatementPrice["_"]

export function statementPriceToData(x: StatementPrice): string {
  return lucid.Data.to<StatementPrice>(x, StatementPrice);
}

export function statementPricefromData(x: string): StatementPrice {
  return lucid.Data.from<StatementPrice>(x, StatementPrice);
}

export type DatumPrice = bp.XDatumPrice["_"]
export const DatumPrice = bp.XDatumPrice["_"]

export function datumPriceToData(x: DatumPrice): string {
  return lucid.Data.to<DatumPrice>(x, DatumPrice);
}

export function datumPricefromData(x: string): DatumPrice {
  return lucid.Data.from<DatumPrice>(x, DatumPrice);
}
